
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2008-2009 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

//
// gw_distfuncdf_support.h
//   Header for the C gateway support functions for DISTFUN
//
#ifndef __SCI_DISTFUN_GWSUPPORT_H__
#define __SCI_DISTFUN_GWSUPPORT_H__

extern double dlamch_(char *, long int);

int distfun_CheckPQEqualOne (char *fname, double* lrP, double* lrQ, int rowsP , int colsP);
int distfun_GetMatrixP( char * fname, int ivar , int rowsExpected, int colsExpected , double** lrP, int * rowsP , int * colsP	);
int distfun_defaultCDFError( char * fname, int status );

int distfun_GetMatricesPQ( char * fname, int ivar, int rowsExpected, int colsExpected ,
	double** lrP, int * rowsP , int * colsP, 
	double** lrQ, int * rowsQ , int * colsQ );
int distfun_CheckXYEqualOne (char *fname, double* lrX, double* lrY, int rowsX , int colsX);

// Get > or >=
int distfun_GetSizedMatrixOfDoublesGreaterOrEqualThanZero( char * fname, int ivar , int rowsExpected, int colsExpected ,
	double** lrA, int * rowsA , int * colsA	);
int distfun_GetSizedMatrixOfDoublesGreaterThanZero( char * fname, int ivar , int rowsExpected, int colsExpected ,
	double** lrA, int * rowsA , int * colsA	);

/* ==================================================================== */

#endif /* __SCI_DISTFUN_GWSUPPORT_H__ */
