// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) ????-2008 - INRIA
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================

// =============================================================================
// Tests for cdfchi() function
// =============================================================================

prec = 1.e-5;

x  = [0.01,0.025,0.05,0.1,0.9,0.95];
function y=chi1(x)
y=exp(-x/2)/sqrt(2*%pi*x)
endfunction
y1 = [];

for xx=x
	y1=[y1,intg(0,xx,chi1)];
end

y2 = distfun_cdfchi(x,ones(x));
if norm(y1-y2) > prec then pause,end 

df       = [1,2,3,4,5,6];
[P,Q]    = distfun_cdfchi(x,df);
Pexpected = [0.0796557    0.0124222    0.0029293    0.0012091    0.0297784    0.0125631];
Qexpected = 1-Pexpected;
assert_checkalmostequal(P,Pexpected,[],1.e-6);
assert_checkalmostequal(Q,Qexpected,[],1.e-6);

