// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2009-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


// Table of inputs from Yalta, 2008
// [x shape scale P ]
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","gamma","gammacdf.yalta.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
x = evstr(table(:,1));
shape = evstr(table(:,2));
scale = evstr(table(:,3));
expected = evstr(table(:,4));
// Caution: this is the rate !
rate = 1 ./ scale;

precision = 1.e-5;
ntests = size(table,"r");
for i = 1 : ntests
  [computed,Q]=distfun_cdfgam(x(i),shape(i),rate(i));
  assert_checkalmostequal ( computed , expected(i) , precision );
  assert_checkalmostequal ( Q , 1 - expected(i) , precision );
  if ( %f ) then
    dp = assert_computedigits ( computed , expected(i) );
    dq = assert_computedigits ( Q , 1 - expected(i) );
    mprintf("Test #%3d/%3d: Digits p1= %.1f, q1=%.1f\n",i,ntests,dp,dq);
  end
end

// Table of inputs computed from R-2.8.1
// [x shape scale PDF-P CDF-P CDF-Q]

path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","gamma","gammacdf.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-12;
precinverse = 1.e-8;

ntests = size(table,"r");
for i = 1 : ntests
  x = table(i,1);
  shape = table(i,2);
  scale = table(i,3);
  p = table(i,5);
  q = table(i,6);
  // Caution: this is the rate !
  rate = 1/scale;
  [p1,q1]=distfun_cdfgam(x,shape,rate);
  if ( %t ) then
    assert_checkalmostequal ( p1 , p , precision );
    assert_checkalmostequal ( q1 , q , precision );
  end
  if ( %f ) then
    dp = assert_computedigits ( p1 , p );
    dq = assert_computedigits ( q1 , q );
    mprintf("Test #%3d/%3d: Digits p1= %.1f, q1=%.1f\n",i,ntests,dp,dq);
  end
end

