// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2009 - 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


x = distfun_invcdfbin([],[],[],[],[]);
assert_checkequal ( x , [] );

//
// Tests from Yalta
// Check Binomial distribution with parameters (k, n = 1030, p = 0.5)
//

path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","cdf","binomialcdf.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
Xk = evstr(table(:,1));
P = evstr(table(:,2));
Q = 1-P;

nt = size(table,"r");
precision = 1.e-5*ones(nt,1);
// The precision is lower for the last tests.
// This is because the dataset is less accurate for the tests 13 and 14,
// for which p is closer and closer to 1.
precision(12:14) = 1.e-2;
for k = 1 : nt
  Pr = 0.5;
  Ompr = 1 - Pr;
  Xn = 1030;
  S=distfun_invcdfbin(Xn,Pr,Ompr,P(k),Q(k));
  assert_checkalmostequal ( S , Xk(k) , precision(k) );
  if ( %f ) then
    dS = assert_computedigits ( S , Xk(k) );
    mprintf("Test #%3d/%3d: Digits S=%.1f\n",k,nt,dS);
  end
end

