// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2009-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

x = distfun_invcdfgam([],[],[],[]);
assert_checkequal ( x , [] );

// Table of inputs from Yalta, 2008
// [x shape scale P ]
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","gamma","gammacdf.yalta.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
x = evstr(table(:,1));
shape = evstr(table(:,2));
scale = evstr(table(:,3));
p = evstr(table(:,4));
q = 1-p;
// Caution: this is the rate !
rate = 1 ./ scale;

precision = 1.e-5;
ntests = size(table,"r");
for i = 1 : ntests
  computed=distfun_invcdfgam(shape(i),rate(i),p(i),q(i));
  assert_checkalmostequal ( computed , x(i) , precision );
  if ( %t ) then
    dx = assert_computedigits ( computed , x(i) );
    mprintf("Test #%3d/%3d: Digits X= %.1f\n",i,ntests,dx);
  end
end

// Table of inputs computed from R-2.8.1
// [x shape scale PDF-P CDF-P CDF-Q]

// For the inversion of Shape, require only 8 digits, as 
// a consequence of bug #7569: http://bugzilla.scilab.org/show_bug.cgi?id=7569
//
// Some tests do not pass:
// http://bugzilla.scilab.org/show_bug.cgi?id=8031
// http://bugzilla.scilab.org/show_bug.cgi?id=8030
//

path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","gamma","gammacdf.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-12;
precinverse = 1.e-8;

ntests = size(table,"r");
for i = 1 : ntests
  x = table(i,1);
  shape = table(i,2);
  scale = table(i,3);
  p = table(i,5);
  q = table(i,6);
  // Caution: this is the rate !
  rate = 1/scale;
  x1     = distfun_invcdfgam(shape,rate,p,q);
  if ( %t ) then
    assert_checkalmostequal ( x1 , x , precision );
  end
  if ( %t ) then
    dx = assert_computedigits ( x1 , x );
    mprintf("Test #%3d/%3d: Digits X= %.1f\n",i,ntests,dx);
  end
end

