// Copyright (C) 2009 - 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

x = distfun_invcdfnor([],[],[],[]);
assert_checkequal ( x , [] );
// 
// Table from Yalta
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","normal","normal.yalta.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-5;
nt = size(table,"r");
for k = 1 : nt
  p = table(k,1);
  x = table(k,2);
  q = 1 - p;
  Mean = 0;
  sigma = 1;
  x1 = distfun_invcdfnor ( Mean , sigma , p , q );
  assert_checkalmostequal ( x1 , x , precision );
  if ( %t ) then
    dx = assert_computedigits ( x1 , x );
    mprintf("Test #%3d/%3d: Digits X=%.1f\n",k,nt,dx);
  end
end

//
// Values from R-2.8.1
// table = [x mu sigma PDF-P CDF-P CDF-Q]
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","normal","normal.R.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-12;
precinv = 1.e-8;

nt = size(table,"r");
for k = 1 : nt
  x = table(k,1);
  mu = table(k,2);
  sigma = table(k,3);
  p = table(k,5);
  q = table(k,6);
  x1 = distfun_invcdfnor(mu,sigma,p,q);
  assert_checkalmostequal ( x1 , x , precinv );
  if ( %t ) then
    dx = assert_computedigits ( x1 , x );
    mprintf("Test #%3d/%3d: Digits X=%.1f\n",k,nt,dx);
  end
end


