// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

x = distfun_invcdfpoi([],[],[]);
assert_checkequal ( x , [] );

//
// Use tests from Yalta
// table = [x lambda p precision]
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","cdf","poisson.yalta.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-5;

nt = size(table,"r");
for k = 1 : nt
  Xk = table(k,1);
  lambda = table(k,2);
  p = table(k,3);
  q = 1-p;
  computed=distfun_invcdfpoi(lambda,p,q);
  assert_checkalmostequal ( computed , Xk , precision );
  if ( %f ) then
    dx = assert_computedigits ( Xk , computed );
    mprintf("Test #%3d/%3d: Digits Xk= %.1f\n",k,nt,dx);
  end
end

//
// Use values from R
// table = [x lambda PDF-P CDF-P CDF-Q]
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","cdf","poisson.R.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);


precision = 1.e-12;
precinv = 1.e-8;
nt = size(table,"r");
for k = 1 : nt
  x = table(k,1);
  lambda = table(k,2);
  p = table(k,4);
  q = table(k,5);
  x1 = distfun_invcdfpoi(lambda,p,q);
  assert_checkalmostequal ( x1 , x , precinv );
  if ( %f ) then
    dx = assert_computedigits ( x1 , x );
    mprintf("Test #%3d/%3d: Digits X=%.1f\n",k,nt,dx);
  end
end


