// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2008 - INRIA - Sabine Gaüzere
// Copyright (C) 2010-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================
// <-- JVM NOT MANDATORY -->

path = distfun_getpath (  );
exec(fullfile(path,"tests","unit_tests","testingutilities.sce"));


rtol = 1.e-1;
atol = 1.e-1;

// The number of classes in the histogram
// NC must be even.
NC = 2*12;
N=10000;

// Set the seed to always get the same random numbers
distfun_seedset(0);

//
// distfun_grandunf
// http://en.wikipedia.org/wiki/Uniform_distribution_(continuous)
//

R = distfun_grandunf(400,800,0,1);
checkMeanVariance ( 400 , 800 , R , 1/2 , 1/12 , rtol );

function p = mycdfdef (X)
  p = X
endfunction
//
R = distfun_grandunf(1,N,0,1);
checkLaw0arg ( R , mycdfdef , N , NC , rtol );

A = 0.1;
B = 2.3;
R = distfun_grandunf(400,800,A,B);
checkMeanVariance ( 400 , 800 , R , (A+B)/2 , (B-A)^2/12 , rtol );

function p = mycdfunf (X,A,B)
  p = (X-A)/(B-A)
endfunction
//
for A = linspace(0.1,0.9,4)
for B = linspace(2.5,4.2,4)
   R = distfun_grandunf(1,N,A,B);
   checkLaw2arg ( R , mycdfunf , N , NC , A , B , rtol , atol );
end
end

// Check expansion of arguments
a = matrix(1:6,2,3);
b = a+1;
checkExpansion2args ( 2 , 3 , distfun_grandunf , a, b);

